--    
If not exists (Select * 
							From	SYSOBJECTS SO,
										SYSCOLUMNS SC
							Where	SO.XTYPE = 'U'
								and SO.[NAME] = 'ABS_VERSION'
								and SO.[ID] = SC.[ID])
	Create table ABS_VERSION 
	       ([id] int IDENTITY (1, 1) not null, -- ID 
	 package_num int not null,	   --  
	package_date datetime not null,	   --  
	     sql_num varchar(15) not null,  --  
	      is_del bit,	   --  
		  se int default 0)--  
	--------------------------
GO


if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[pABSUpdateAddVersion]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	drop procedure [dbo].[pABSUpdateAddVersion]
GO

SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO

CREATE PROCEDURE dbo.pABSUpdateAddVersion
	@iPackageNum int,    	-- id 
	@sSqlNum varchar(15), 	--  
	@DBaseName varchar(15)  --   
 AS
Set Nocount ON
/* =====================================================================
        ABSUpdate

    ..
    : 25-03-2008
    : 
   ===================================================================== */
 DECLARE @SQLString NVARCHAR(255)
 DECLARE @v_param   NVARCHAR(255)
 DECLARE @v_pom     INT
 SET @v_pom = NULL

      --   
      SET @SQLString = 'SELECT @v_pomOUT = 1 WHERE EXISTS(select 1 from ' + @DBaseName + '..ABS_VERSION where package_num = ' + cast(@iPackageNum as varchar(15)) + ' and sql_num = '''+ @sSqlNum + ''')'
      SET @v_param   = '@v_pomOUT tinyint OUTPUT'
      EXECUTE sp_executesql @SQLString, @v_param, @v_pomOUT=@v_pom OUTPUT


if exists(select 1 from ABS_VERSION where package_num = @iPackageNum and sql_num = @sSqlNum)
	UPDATE ABS_VERSION
	set package_date = getdate(), is_del = 0, se = se+1
	where package_num = @iPackageNum and sql_num = @sSqlNum
else
	INSERT ABS_VERSION (package_num, package_date, sql_num, is_del, se)
	values (@iPackageNum, getdate(), @sSqlNum, 0, 0)

--        (    )
if @v_pom = 1 
       set @SQLString = 
	'UPDATE '+ @DBaseName +'..ABS_VERSION '+
	'set package_date = '''+ cast(getdate() as varchar(20)) +''', is_del = 0, se = case when se < 0 then se-1 else se+1 end '+
	'where package_num = '+ cast(@iPackageNum as varchar(15)) +'and sql_num = '''+ @sSqlNum +''''
else
       set @SQLString = 
	'INSERT '+ @DBaseName +'..ABS_VERSION (package_num, package_date, sql_num, is_del, se)'+
	'values ('+ cast(@iPackageNum as varchar(15)) +', '''+ cast(getdate() as varchar(20)) +''', '''+ @sSqlNum +''', 0, 0)'

exec (@SQLString)

GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO


if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[pABSUpdateGetVersion]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	drop procedure [dbo].[pABSUpdateGetVersion]
GO

SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO

CREATE PROCEDURE dbo.pABSUpdateGetVersion
	@iPackageNum int, 	-- id 
	@DBaseName varchar(15)  --   
 AS
Set Nocount ON
/* =====================================================================
         ABSUpdate

    ..
    : 25-03-2008
    : 
   ===================================================================== */
declare @PrevVersion as int, @PackageNum as int, @se as int
DECLARE @SQLString NVARCHAR(255)
DECLARE @v_param  NVARCHAR(50)
DECLARE @v_1OUT INT, @v_2OUT INT

select @PrevVersion = isnull(max(package_num),0) from ABS_VERSION

      SET @SQLString = 'select top 1 @v_1OUT = package_num, @v_2OUT = se from '+ @DBaseName +'..ABS_VERSION '+
		       'where is_del <> 1 '+
		       'order by package_num desc, se'
      SET @v_param   = '@v_1OUT tinyint OUTPUT, @v_2OUT tinyint OUTPUT'
      EXECUTE sp_executesql @SQLString, @v_param, @v_1OUT=@PackageNum OUTPUT, @v_2OUT=@se OUTPUT

if @iPackageNum = -1
	set @iPackageNum = @PackageNum

--     .  
set @SQLString = 
'select max(package_num) package_num, sql_num from '+ @DBaseName +'..ABS_VERSION where is_del <> 1 and sql_num not in (select sql_num from ABS_VERSION) '+
'group by sql_num'

exec (@SQLString)

select @PackageNum, @se

GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO



if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[pABSUpdateGetVersions]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	drop procedure [dbo].[pABSUpdateGetVersions]
GO

SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO

CREATE PROCEDURE dbo.pABSUpdateGetVersions 
	@DBaseName varchar(15)  --   
 AS
Set Nocount ON
/* =====================================================================
       -  , . .

    ..
    : 25-03-2008
    : 
   ===================================================================== */
DECLARE @SQLString NVARCHAR(500)

set @SQLString = 
'select top 1 isnull(v1.package_num, 0) as DBVer, isnull(v1.package_date, cast(''1999-1-1'' as datetime)) as package_date, v2.package_num as SoftVer, v2.se '+
'from '+ @DBaseName +'..ABS_VERSION V2 left outer join ABS_VERSION V1 on 1=1 '+
'where (v1.is_del <> 1 or v1.is_del is null) and v2.is_del <> 1 '+
'order by v1.package_num desc, v1.package_date desc, v2.package_num desc, v2.se'

exec(@SQLString)
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

